$(function () {
    var userData = $("#userData");
    var updateButton = $("#updateGraph");
    var canvas = $("#myChart").get(0);
    var ctx = canvas.getContext("2d");
    var freqMin = $("#freqMin");
    var freqMax = $("#freqMax");
    var myBarChart;
    
    var data = {
        labels: [],
        datasets: [
            {
                label: "Word Frequencies",
                fillColor: "rgba(151,187,205,0.5)",
                strokeColor: "rgba(151,187,205,0.8)",
                highlightFill: "rgba(151,187,205,0.75)",
                highlightStroke: "rgba(151,187,205,1)",
                data: []
            }
        ]
    };
    
    function wordFreq(words) {
        var freq = {};

        words.forEach(function(w) {
            if (w === '') {
                return;
            }
            
            if (freq[w]) {
                freq[w]++;
            } else {
                freq[w] = 1;
            }
        });

        return freq;
    }

    function freqCompare(a, b) {
        // Notice the comparisons are reversed since we want
        // the most frequent to be in index 0.
        if (a.freq > b.freq) {
            return -1;
        } else if (a.freq < b.freq) {
            return 1;
        } else {
            return 0;
        }
    }

    function updateGraph() {
        var start = freqMin.val();
        var end = freqMax.val();
	var text, words, freq, labels;
	var freqArray, sortedFreq, sortedLabels, sortedValues;
	
	var sortOrder = $("input:radio[name=sortOrder]:checked").val()
	
        text = userData.val();
        words = text.split(/\W/);
        freq = wordFreq(words);
        labels = Object.keys(freq).sort();

	if (sortOrder === 'freq') {	
            freqArray = labels.map(function(word) {
		return {word: word, freq: freq[word]};
            });
            sortedFreq = freqArray.sort(freqCompare);
            sortedLabels = sortedFreq.map(function(f) {
		return f.word;
            });
            sortedValues = sortedFreq.map(function(f) {
		return f.freq;
            });
	} else { /// sortOrder === 'alpha'
	    sortedLabels = labels;
	    sortedValues = labels.map(function(word) {
		return freq[word];
	    });
	}
	
        data.labels = sortedLabels.slice(start, end);
        data.datasets[0].data = sortedValues.slice(start, end);

        if (myBarChart) {
            myBarChart.destroy();
        }

        myBarChart = new Chart(ctx).Bar(data, {});
    }

    updateButton.click(updateGraph);
    userData.val("Please enter the text to analyze here.");
});
